diff --git a/web/config/environments/production.rb b/web/config/environments/production.rb
index b991b661..5cb41acd 100644
--- a/web/config/environments/production.rb
+++ b/web/config/environments/production.rb
@@ -99,5 +99,14 @@ Rails.application.configure do
   # without same-origin, an unset origin silently dropped every live
   # update on any non-localhost URL — a trap on the install path.
   config.action_cable.allow_same_origin_as_host = true
-  config.action_cable.allowed_request_origins = [ ENV["HIVEBOX_ORIGIN"] ].compact
+  config.action_cable.allowed_request_origins =
+    [ ENV["HIVE_WEB_ORIGIN"] || ENV["HIVEBOX_ORIGIN"] ].compact
+
+  # Host authorization remains active in every security mode. IPAddr matches
+  # the complete loopback ranges (including 127.0.0.2), while non-loopback
+  # binds add only their explicitly configured host.
+  require "hive/web/host_authorization"
+  bind = ENV["HIVE_WEB_BIND"] || ENV["HIVEBOX_BIND"] || "127.0.0.1"
+  origin = ENV["HIVE_WEB_ORIGIN"] || ENV["HIVEBOX_ORIGIN"]
+  config.hosts = Hive::Web::HostAuthorization.allowed_hosts(bind: bind, origin: origin)
 end
diff --git a/web/config/initializers/hive.rb b/web/config/initializers/hive.rb
index f2792b55..7aa6f994 100644
--- a/web/config/initializers/hive.rb
+++ b/web/config/initializers/hive.rb
@@ -10,3 +10,4 @@ require "hive/web/telegram_validator"
 require "hive/web/telegram_tester"
 require "hive/commands/init"
 require "hive/commands/approve"
+require "hive/pid_file"
diff --git a/web/config/initializers/hive_web_environment.rb b/web/config/initializers/hive_web_environment.rb
new file mode 100644
index 00000000..07f85c15
--- /dev/null
+++ b/web/config/initializers/hive_web_environment.rb
@@ -0,0 +1,6 @@
+require "ipaddr"
+
+Rails.application.config.x.hive_web_local_mode =
+  ENV.fetch("HIVE_WEB_LOCAL_MODE", "false") == "true"
+Rails.application.config.x.hive_web_bind =
+  ENV["HIVE_WEB_BIND"] || ENV["HIVEBOX_BIND"] || "127.0.0.1"
diff --git a/web/config/routes.rb b/web/config/routes.rb
index 659576df..d1bdb4de 100644
--- a/web/config/routes.rb
+++ b/web/config/routes.rb
@@ -16,6 +16,9 @@ Rails.application.routes.draw do
   post "logout" => "sessions#destroy", as: :logout
 
   root "status#index"
+  post "daemon/:operation" => "daemon#maintain",
+       as: :daemon_maintenance,
+       constraints: { operation: /repair|restart/ }
 
   post "ideas" => "ideas#create", as: :ideas
 
diff --git a/web/test/controllers/daemon_controller_test.rb b/web/test/controllers/daemon_controller_test.rb
new file mode 100644
index 00000000..0b6c22eb
--- /dev/null
+++ b/web/test/controllers/daemon_controller_test.rb
@@ -0,0 +1,24 @@
+require "test_helper"
+
+class DaemonControllerTest < ActionDispatch::IntegrationTest
+  test "maintenance routes are POST-only and closed to fixed actions" do
+    sign_in!
+
+    get "/daemon/restart"
+    assert_response :not_found
+
+    post "/daemon/arbitrary"
+    assert_response :not_found
+  end
+
+  test "status page exposes bounded daemon actions" do
+    sign_in!
+
+    get "/"
+
+    assert_response :success
+    assert_select "section.daemon-card"
+    assert_select "form[action='/daemon/repair']"
+    assert_select "form[action='/daemon/restart']", count: 0
+  end
+end
diff --git a/web/test/integration/local_loopback_auth_test.rb b/web/test/integration/local_loopback_auth_test.rb
new file mode 100644
index 00000000..77bd2274
--- /dev/null
+++ b/web/test/integration/local_loopback_auth_test.rb
@@ -0,0 +1,37 @@
+require "test_helper"
+
+class LocalLoopbackAuthTest < ActionDispatch::IntegrationTest
+  setup do
+    @old_mode = Rails.application.config.x.hive_web_local_mode
+    @old_bind = Rails.application.config.x.hive_web_bind
+    Rails.application.config.x.hive_web_local_mode = true
+    Rails.application.config.x.hive_web_bind = "127.0.0.1"
+  end
+
+  teardown do
+    Rails.application.config.x.hive_web_local_mode = @old_mode
+    Rails.application.config.x.hive_web_bind = @old_bind
+  end
+
+  test "genuine loopback request bypasses login in local mode" do
+    get "/", env: { "REMOTE_ADDR" => "127.0.0.1" }
+
+    assert_response :success
+  end
+
+  test "forwarded header cannot spoof loopback peer" do
+    get "/",
+        headers: { "X-Forwarded-For" => "127.0.0.1" },
+        env: { "REMOTE_ADDR" => "203.0.113.9" }
+
+    assert_redirected_to "/login"
+  end
+
+  test "non-loopback configured bind disables bypass" do
+    Rails.application.config.x.hive_web_bind = "0.0.0.0"
+
+    get "/", env: { "REMOTE_ADDR" => "127.0.0.1" }
+
+    assert_redirected_to "/login"
+  end
+end
diff --git a/web/test/integration/production_host_authorization_test.rb b/web/test/integration/production_host_authorization_test.rb
new file mode 100644
index 00000000..b9f7766d
--- /dev/null
+++ b/web/test/integration/production_host_authorization_test.rb
@@ -0,0 +1,32 @@
+require "test_helper"
+require "action_dispatch"
+require "rack/mock"
+require "hive/web/host_authorization"
+
+class ProductionHostAuthorizationTest < ActiveSupport::TestCase
+  def authorized_app(bind: "127.0.0.1", origin: nil)
+    hosts = Hive::Web::HostAuthorization.allowed_hosts(bind: bind, origin: origin)
+    ActionDispatch::HostAuthorization.new(
+      ->(_env) { [ 200, { "content-type" => "text/plain" }, [ "ok" ] ] },
+      hosts
+    )
+  end
+
+  test "accepts any loopback address while rejecting an unconfigured host" do
+    app = authorized_app
+
+    assert_equal 200, Rack::MockRequest.new(app).get("/", "HTTP_HOST" => "127.0.0.2").status
+    assert_equal 403, Rack::MockRequest.new(app).get("/", "HTTP_HOST" => "attacker.example").status
+  end
+
+  test "non-loopback mode retains host authorization for the configured origin" do
+    app = authorized_app(bind: "0.0.0.0", origin: "https://hive.internal.example")
+
+    assert_equal 200,
+                 Rack::MockRequest.new(app).get("/", "HTTP_HOST" => "192.0.2.10").status
+    assert_equal 200,
+                 Rack::MockRequest.new(app).get("/", "HTTP_HOST" => "hive.internal.example").status
+    assert_equal 403,
+                 Rack::MockRequest.new(app).get("/", "HTTP_HOST" => "spoofed.example").status
+  end
+end
